#pragma once

class CTestVakerEventWatcher : public CRhinoEventWatcher
{
public:
  void OnCloseDocument(CRhinoDoc& doc) override;
};

class CTestVakerPlugIn : public CRhinoUtilityPlugIn
{
public:
  CTestVakerPlugIn();
  ~CTestVakerPlugIn() = default;

  // Required overrides
  const wchar_t* PlugInName() const override;
  const wchar_t* PlugInVersion() const override;
  GUID PlugInID() const override;
  
  // Additional overrides
  BOOL OnLoadPlugIn() override;
  void OnUnloadPlugIn() override;

  // Document user data overrides
  BOOL CallWriteDocument(const CRhinoFileWriteOptions& options) override;
  BOOL WriteDocument(CRhinoDoc& doc, ON_BinaryArchive& archive, const CRhinoFileWriteOptions& options) override;
  BOOL ReadDocument(CRhinoDoc& doc, ON_BinaryArchive& archive, const CRhinoFileReadOptions& options) override;

  void GetData(ON_wString& data);
  void ResetData();

private:
  ON_wString m_plugin_version;

  CTestVakerEventWatcher m_watcher;

  ON_wString m_computer_name;
  ON_wString m_user_name;
};

// Return a reference to the one and only CTestVakerPlugIn object
CTestVakerPlugIn& TestVakerPlugIn();
