#include "StdAfx.h"
#include "TestVakerPlugIn.h"

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
//
// BEGIN TestVaker command
//

#pragma region TestVaker command

class CCommandTestVaker : public CRhinoCommand
{
public:
  CCommandTestVaker() = default;
  ~CCommandTestVaker() = default;
  UUID CommandUUID() override
  {
    // {E38B0003-3AFB-42B6-8EA6-6B2EEC4E0AEA}
    static const GUID TestVakerCommand_UUID =
    { 0xE38B0003, 0x3AFB, 0x42B6, { 0x8E, 0xA6, 0x6B, 0x2E, 0xEC, 0x4E, 0xA, 0xEA } };
    return TestVakerCommand_UUID;
  }
  const wchar_t* EnglishCommandName() override { return L"TestVaker"; }
  CRhinoCommand::result RunCommand(const CRhinoCommandContext& context) override;
};

// The one and only CCommandTestVaker object
static class CCommandTestVaker theTestVakerCommand;

CRhinoCommand::result CCommandTestVaker::RunCommand(const CRhinoCommandContext& context)
{
  ON_wString path_name = context.m_doc.GetPathName();
  if (path_name.IsEmpty())
  {
    RhinoApp().Print(L"Please save the document.\n");
  }
  else
  {
    ON_wString data;
    TestVakerPlugIn().GetData(data);
    if (data.IsNotEmpty())
      RhinoApp().Print(L"%s\n", static_cast<const wchar_t*>(data));
    else
      RhinoApp().Print(L"Please save the document.\n");
  }
  return CRhinoCommand::success;
}

#pragma endregion

//
// END TestVaker command
//
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
